#NoEnv

; Add resources to the compiled script
;@Ahk2Exe-AddResource ResourceDemo.bmp
;@Ahk2Exe-AddResource ResourceDemo.html

; Run a PostExec AHK program (this one simply shows parameters passed)
;@Ahk2Exe-PostExec %A_ScriptFullPath~\.[^\.]+$~PostExec.ahk% "%A_WorkFileName%" %A_ScriptName~\.[^\.]+$~.exe% 

;@Ahk2Exe-IgnoreBegin
MsgBox You must run this as a compiled script!
ExitApp
;@Ahk2Exe-IgnoreEnd

; Create HTML control and embed our HTML resource
Gui, Add, ActiveX, w400 h200 vWB, Shell.Explorer
WB.Navigate("res://" A_ScriptFullPath "/ResourceDemo.html")

; Create image control and assign it our bitmap resource
Gui, Add, Text, w400 h200 +0xE hwndhPicCtrl
SetBitmap(hPicCtrl, LoadBitmapResource("ResourceDemo.bmp"))

Gui, Show,, Resource Demo
return

GuiClose:
ExitApp

GetOwnModuleHandle()
{
	static h := DllCall("GetModuleHandle", "ptr", 0, "ptr")
	return h
}

LoadBitmapResource(resName, shared := true)
{
	resNameType := "str"
	if resName is integer
		if resName between 0 and 0xFFFF
			resNameType := "ptr"
	if not ret := DllCall("LoadImage", "ptr", GetOwnModuleHandle(), resNameType, resName, "uint", 0, "int", 0, "int", 0, "uint", shared ? 0x8000 : 0, "ptr")
		throw Exception("Could not load bitmap!", -1, "resName: " resName " - ErrLvl: " ErrorLevel " - LastErr: " A_LastError)
	return ret
}

SetBitmap(hPicCtrl, hBitmap, guiName := "")
{
	prefix := guiName ? guiName ":" : ""
	GuiControlGet, temp, %prefix%Pos, %hPicCtrl%
	SendMessage, 0x172, 0, hBitmap,, ahk_id %hPicCtrl% ; 0x172=STM_SETIMAGE, 0=IMAGE_BITMAP
	GuiControl, %prefix%Move, %hPicCtrl%, w%tempW% h%tempH% ; Make sure the bitmap is resized to fit the control
}
